function f = fun1( x,ch )


%%%% RATE 1 %%%%
% Compute H(U|Y1)
py1_0 = x(1)* ((1-x(2))*(1-ch(2)) + x(2)*ch(2)) ...
           + (1-x(1))* (x(3)*(1-ch(2)) + (1-x(3))*ch(2));
py1_0_u_0 = (1-x(2))*(1-ch(2)) + x(2)*ch(2);
pu_0_y1_0 = (py1_0_u_0 * x(1) ) / py1_0;
pu_0_y1_1 = ((1-py1_0_u_0) * x(1) ) / (1-py1_0);
HU_Y1 = py1_0*bh(pu_0_y1_0) + (1-py1_0)*bh(pu_0_y1_1);
% Compute H(U|Z2)
pz2_0 = x(1)* ((1-x(2))*(1-ch(3)) + x(2)*ch(3)) ...
           + (1-x(1))* (x(3)*(1-ch(3)) + (1-x(3))*ch(3));
pz2_0_u_0 = (1-x(2))*(1-ch(3)) + x(2)*ch(3);
pu_0_z2_0 = (pz2_0_u_0 * x(1) ) / pz2_0;
pu_0_z2_1 = ((1-pz2_0_u_0) * x(1) ) / (1-pz2_0);
HU_Z2 = pz2_0*bh(pu_0_z2_0) + (1-pz2_0)*bh(pu_0_z2_1);
% R1:
R1 = HU_Z2 - HU_Y1;


%%%% RATE 2 %%%%
% Compute H(X|U,Y2)
py2_0_u0 = (1-x(2))*(1-ch(1)) + x(2)*ch(1);
py2_0_u1 = x(3)*(1-ch(1)) + (1-x(3))*ch(1);
py2_0_u0x0 = 1-ch(1);
py2_0_u1x0 = 1-ch(1);
pu0x0 = x(1)*(1-x(2));
pu1x0 = (1-x(1))*x(3);
px0_u0y20 = (py2_0_u0x0 * pu0x0) / (x(1)*py2_0_u0);
px0_u0y21 = ((1-py2_0_u0x0) * pu0x0) / (x(1)*(1-py2_0_u0));
px0_u1y20 = (py2_0_u1x0 * pu1x0) / ((1-x(1))*py2_0_u1);
px0_u1y21 = ((1-py2_0_u1x0) * pu1x0) / ((1-x(1))*(1-py2_0_u1));
HX_UY2 = x(1)*py2_0_u0*bh(px0_u0y20) + x(1)*(1-py2_0_u0)*bh(px0_u0y21)...
    + (1-x(1))*py2_0_u1*bh(px0_u1y20) + (1-x(1))*(1-py2_0_u1)*bh(px0_u1y21);
% Compute H(X|U,Z2)
pz2_0_u0 = (1-x(2))*(1-ch(3)) + x(2)*ch(3);
pz2_0_u1 = x(3)*(1-ch(3)) + (1-x(3))*ch(3);
pz2_0_u0x0 = 1-ch(3);
pz2_0_u1x0 = 1-ch(3);
px0_u0z20 = (pz2_0_u0x0 * pu0x0) / (x(1)*pz2_0_u0);
px0_u0z21 = ((1-pz2_0_u0x0) * pu0x0) / (x(1)*(1-pz2_0_u0));
px0_u1z20 = (pz2_0_u1x0 * pu1x0) / ((1-x(1))*pz2_0_u1);
px0_u1z21 = ((1-pz2_0_u1x0) * pu1x0) / ((1-x(1))*(1-pz2_0_u1));
HX_UZ2 = x(1)*pz2_0_u0*bh(px0_u0z20) + x(1)*(1-pz2_0_u0)*bh(px0_u0z21)...
    + (1-x(1))*pz2_0_u1*bh(px0_u1z20) + (1-x(1))*(1-pz2_0_u1)*bh(px0_u1z21);
% R2:
R2 = HX_UZ2 - HX_UY2;

f = -log(R1)-log(R2);


end

