function [R1,R2,CHo,CHoCell] = fun1ev( x,ch )


%%%% RATE 1 %%%%
% Compute H(U|Y1)
py1_0 = x(1)* ((1-x(2))*(1-ch(2)) + x(2)*ch(2)) ...
           + (1-x(1))* (x(3)*(1-ch(2)) + (1-x(3))*ch(2));
py1_0_u_0 = (1-x(2))*(1-ch(2)) + x(2)*ch(2);
pu_0_y1_0 = (py1_0_u_0 * x(1) ) / py1_0;
pu_0_y1_1 = ((1-py1_0_u_0) * x(1) ) / (1-py1_0);
HU_Y1 = py1_0*bh(pu_0_y1_0) + (1-py1_0)*bh(pu_0_y1_1);
% Compute H(U|Z2)
pz2_0 = x(1)* ((1-x(2))*(1-ch(3)) + x(2)*ch(3)) ...
           + (1-x(1))* (x(3)*(1-ch(3)) + (1-x(3))*ch(3));
pz2_0_u_0 = (1-x(2))*(1-ch(3)) + x(2)*ch(3);
pu_0_z2_0 = (pz2_0_u_0 * x(1) ) / pz2_0;
pu_0_z2_1 = ((1-pz2_0_u_0) * x(1) ) / (1-pz2_0);
HU_Z2 = pz2_0*bh(pu_0_z2_0) + (1-pz2_0)*bh(pu_0_z2_1);
% R1:
R1 = HU_Z2 - HU_Y1;


%%%% RATE 2 %%%%
% Compute H(X|U,Y2)
py2_0_u0 = (1-x(2))*(1-ch(1)) + x(2)*ch(1);
py2_0_u1 = x(3)*(1-ch(1)) + (1-x(3))*ch(1);
py2_0_u0x0 = 1-ch(1);
py2_0_u1x0 = 1-ch(1);
pu0x0 = x(1)*(1-x(2));
pu1x0 = (1-x(1))*x(3);
px0_u0y20 = (py2_0_u0x0 * pu0x0) / (x(1)*py2_0_u0);
px0_u0y21 = ((1-py2_0_u0x0) * pu0x0) / (x(1)*(1-py2_0_u0));
px0_u1y20 = (py2_0_u1x0 * pu1x0) / ((1-x(1))*py2_0_u1);
px0_u1y21 = ((1-py2_0_u1x0) * pu1x0) / ((1-x(1))*(1-py2_0_u1));
HX_UY2 = x(1)*py2_0_u0*bh(px0_u0y20) + x(1)*(1-py2_0_u0)*bh(px0_u0y21)...
    + (1-x(1))*py2_0_u1*bh(px0_u1y20) + (1-x(1))*(1-py2_0_u1)*bh(px0_u1y21);
% Compute H(X|U,Z2)
pz2_0_u0 = (1-x(2))*(1-ch(3)) + x(2)*ch(3);
pz2_0_u1 = x(3)*(1-ch(3)) + (1-x(3))*ch(3);
pz2_0_u0x0 = 1-ch(3);
pz2_0_u1x0 = 1-ch(3);
px0_u0z20 = (pz2_0_u0x0 * pu0x0) / (x(1)*pz2_0_u0);
px0_u0z21 = ((1-pz2_0_u0x0) * pu0x0) / (x(1)*(1-pz2_0_u0));
px0_u1z20 = (pz2_0_u1x0 * pu1x0) / ((1-x(1))*pz2_0_u1);
px0_u1z21 = ((1-pz2_0_u1x0) * pu1x0) / ((1-x(1))*(1-pz2_0_u1));
HX_UZ2 = x(1)*pz2_0_u0*bh(px0_u0z20) + x(1)*(1-pz2_0_u0)*bh(px0_u0z21)...
    + (1-x(1))*pz2_0_u1*bh(px0_u1z20) + (1-x(1))*(1-pz2_0_u1)*bh(px0_u1z21);
% R2:
R2 = HX_UZ2 - HX_UY2;


CHout = cell(1,8);
CHCellout = cell(1,8);
%%%% CHANNEL 1 - (U-Y2) %%%%
py2_0 = x(1)* ((1-x(2))*(1-ch(1)) + x(2)*ch(1)) ...
    + (1-x(1))* (x(3)*(1-ch(1)) + (1-x(3))*ch(1));
py2_0_u_0 = (1-x(2))*(1-ch(1)) + x(2)*ch(1);
py2_0_u_1 = (1-x(3))*ch(1) + x(3)*(1-ch(1));
pu_0_y2_0 = (py2_0_u_0 * x(1) ) / py2_0;    
pu_0_y2_1 = ((1-py2_0_u_0) * x(1) ) / (1-py2_0);  

o.ChannelName = 'U_Y2';
o.Px = [x(1),1-x(1)];
o.Py = [py2_0,1-py2_0];
o.Pxy = [x(1)*py2_0 , x(1)*(1-py2_0);...
         (1-x(1))*py2_0 , (1-x(1))*(1-py2_0)];
o.Px_y = [pu_0_y2_0 , pu_0_y2_1;...
          (1-pu_0_y2_0), (1-pu_0_y2_1)];
o.Py_x = [py2_0_u_0, py2_0_u_1;...
          (1-py2_0_u_0), (1-py2_0_u_1)];
o.Hx = bh(x(1));
o.Hy = bh(py2_0);
o.Hx_y = py2_0*bh(pu_0_y2_0) + (1-py2_0)*bh(pu_0_y2_1);
o.Hy_x = x(1)*bh(py2_0_u_0) + (1-x(1))*bh(py2_0_u_1);
o.Hxy = entrop([x(1)*py2_0_u_0,x(1)*(1-py2_0_u_0),...
              (1-x(1))*py2_0_u_1,(1-x(1))*(1-py2_0_u_1)]);
% o.Capacity = Capacity;
% o.Z = Z;
CHout{1} = o;
CHCellout{1} = o.Py_x;


%%%% CHANNEL 2 - (U-Y1) %%%%
py1_0_u_1 = (1-x(3))*ch(2) + x(3)*(1-ch(2));

o.ChannelName = 'U_Y1';
o.Px = [x(1),1-x(1)];
o.Py = [py1_0,1-py1_0];
o.Pxy = [x(1)*py1_0 , x(1)*(1-py1_0);...
         (1-x(1))*py1_0 , (1-x(1))*(1-py1_0)];
o.Px_y = [pu_0_y1_0 , pu_0_y1_1;...
          (1-pu_0_y1_0), (1-pu_0_y1_1)];
o.Py_x = [py1_0_u_0, py1_0_u_1;...
          (1-py1_0_u_0), (1-py1_0_u_1)];
o.Hx = bh(x(1));
o.Hy = bh(py1_0);
o.Hx_y = py1_0*bh(pu_0_y1_0) + (1-py1_0)*bh(pu_0_y1_1);
o.Hy_x = x(1)*bh(py1_0_u_0) + (1-x(1))*bh(py1_0_u_1);
o.Hxy = entrop([x(1)*py1_0_u_0,x(1)*(1-py1_0_u_0),...
              (1-x(1))*py1_0_u_1,(1-x(1))*(1-py1_0_u_1)]);
CHout{2} = o;
CHCellout{2} = o.Py_x;


%%%% CHANNEL 3 - (U-Z2) %%%%
pz2_0_u_1 = (1-x(3))*ch(3) + x(3)*(1-ch(3));

o.ChannelName = 'U_Z2';
o.Px = [x(1),1-x(1)];
o.Py = [pz2_0,1-pz2_0];
o.Pxy = [x(1)*pz2_0 , x(1)*(1-pz2_0);...
         (1-x(1))*pz2_0 , (1-x(1))*(1-pz2_0)];
o.Px_y = [pu_0_z2_0 , pu_0_z2_1;...
          (1-pu_0_z2_0), (1-pu_0_z2_1)];
o.Py_x = [pz2_0_u_0, pz2_0_u_1;...
          (1-pz2_0_u_0), (1-pz2_0_u_1)];
o.Hx = bh(x(1));
o.Hy = bh(pz2_0);
o.Hx_y = py1_0*bh(pu_0_z2_0) + (1-py1_0)*bh(pu_0_z2_1);
o.Hy_x = x(1)*bh(pz2_0_u_0) + (1-x(1))*bh(pz2_0_u_1);
o.Hxy = entrop([x(1)*pz2_0_u_0,x(1)*(1-pz2_0_u_0),...
              (1-x(1))*pz2_0_u_1,(1-x(1))*(1-pz2_0_u_1)]);
CHout{3} = o;
CHCellout{3} = o.Py_x;



%%%% CHANNEL 4 - (U-Z1) %%%%
pz1_0 = x(1)* ((1-x(2))*(1-ch(4)) + x(2)*ch(4)) ...
    + (1-x(1))* (x(3)*(1-ch(4)) + (1-x(3))*ch(4));
pz1_0_u_0 = (1-x(2))*(1-ch(4)) + x(2)*ch(4);
pz1_0_u_1 = (1-x(3))*ch(4) + x(3)*(1-ch(4));
pu_0_z1_0 = (pz1_0_u_0 * x(1) ) / pz1_0;    
pu_0_z1_1 = ((1-pz1_0_u_0) * x(1) ) / (1-pz1_0);  

o.ChannelName = 'U_Z1';
o.Px = [x(1),1-x(1)];
o.Py = [pz1_0,1-pz1_0];
o.Pxy = [x(1)*pz1_0 , x(1)*(1-pz1_0);...
         (1-x(1))*pz1_0 , (1-x(1))*(1-pz1_0)];
o.Px_y = [pu_0_z1_0 , pu_0_z1_1;...
          (1-pu_0_z1_0), (1-pu_0_z1_1)];
o.Py_x = [pz1_0_u_0, pz1_0_u_1;...
          (1-pz1_0_u_0), (1-pz1_0_u_1)];
o.Hx = bh(x(1));
o.Hy = bh(pz1_0);
o.Hx_y = pz1_0*bh(pu_0_z1_0) + (1-pz1_0)*bh(pu_0_z1_1);
o.Hy_x = x(1)*bh(pz1_0_u_0) + (1-x(1))*bh(pz1_0_u_1);
o.Hxy = entrop([x(1)*pz1_0_u_0,x(1)*(1-pz1_0_u_0),...
              (1-x(1))*pz1_0_u_1,(1-x(1))*(1-pz1_0_u_1)]);
% o.Capacity = Capacity;
% o.Z = Z;
CHout{4} = o;
CHCellout{4} = o.Py_x;




%%%% CHANNEL 5 - (X-(U,Y2)) %%%%
px0 = x(1)*(1-x(2))+(1-x(1))*x(3);
pu0x1 = x(1)*x(2);
pu1x1 = (1-x(1))*(1-x(3));
py2_0_u0x1 = ch(1);
py2_0_u1x1 = ch(1);

o.ChannelName = 'X_UY2';
o.Px = [px0,1-px0];
o.Py = [x(1)*py2_0_u0,x(1)*(1-py2_0_u0),(1-x(1))*py2_0_u1,(1-x(1))*(1-py2_0_u1)]; 
o.Pxy = [pu0x0*py2_0_u0x0, pu0x0*(1-py2_0_u0x0), pu1x0*py2_0_u1x0, pu1x0*(1-py2_0_u1x0);...
         pu0x1*py2_0_u0x1, pu0x1*(1-py2_0_u0x1), pu1x1*py2_0_u1x1, pu1x1*(1-py2_0_u1x1)];
o.Px_y = [px0_u0y20 , px0_u0y21, px0_u1y20, px0_u1y21;...
          (1-px0_u0y20), (1-px0_u0y21), (1-px0_u1y20), (1-px0_u1y21)];
o.Py_x = [(pu0x0*py2_0_u0x0)/px0, (pu0x1*py2_0_u0x1)/(1-px0);...
          (pu0x0*(1-py2_0_u0x0))/px0, (pu0x1*(1-py2_0_u0x1))/(1-px0);...
          (pu1x0*py2_0_u1x0)/px0, pu1x1*py2_0_u1x1/(1-px0);...
          (pu1x0*(1-py2_0_u1x0))/px0, (pu1x1*(1-py2_0_u1x1))/(1-px0)];
o.Hx = bh(px0);
o.Hy = entrop(o.Py);
o.Hx_y = x(1)*py2_0_u0*bh(px0_u0y20) + x(1)*(1-py2_0_u0)*bh(px0_u0y21)...
    + (1-x(1))*py2_0_u1*bh(px0_u1y20) + (1-x(1))*(1-py2_0_u1)*bh(px0_u1y21);
o.Hy_x = px0*entrop(o.Py_x(:,1)) + (1-px0)*entrop(o.Py_x(:,2));
o.Hxy = entrop([o.Pxy(1,:),o.Pxy(2,:)]);
% o.Capacity = Capacity;
% o.Z = Z;
CHout{5} = o;
CHCellout{5} = o.Py_x';



%%%% CHANNEL 6 - (X-(U,Z2)) %%%%
pz2_0_u0x1 = ch(3);
pz2_0_u1x1 = ch(3);

o.ChannelName = 'X_UZ2';
o.Px = [px0,1-px0];
o.Py = [x(1)*pz2_0_u0,x(1)*(1-pz2_0_u0),(1-x(1))*pz2_0_u1,(1-x(1))*(1-pz2_0_u1)]; 
o.Pxy = [pu0x0*pz2_0_u0x0, pu0x0*(1-pz2_0_u0x0), pu1x0*pz2_0_u1x0, pu1x0*(1-pz2_0_u1x0);...
         pu0x1*pz2_0_u0x1, pu0x1*(1-pz2_0_u0x1), pu1x1*pz2_0_u1x1, pu1x1*(1-pz2_0_u1x1)];
o.Px_y = [px0_u0z20 , px0_u0z21, px0_u1z20, px0_u1z21;...
          (1-px0_u0z20), (1-px0_u0z21), (1-px0_u1z20), (1-px0_u1z21)];
o.Py_x = [(pu0x0*pz2_0_u0x0)/px0, (pu0x1*pz2_0_u0x1)/(1-px0);...
          (pu0x0*(1-pz2_0_u0x0))/px0, (pu0x1*(1-pz2_0_u0x1))/(1-px0);...
          (pu1x0*pz2_0_u1x0)/px0, pu1x1*pz2_0_u1x1/(1-px0);...
          (pu1x0*(1-pz2_0_u1x0))/px0, (pu1x1*(1-pz2_0_u1x1))/(1-px0)];
o.Hx = bh(px0);
o.Hy = entrop(o.Py);
o.Hx_y = x(1)*pz2_0_u0*bh(px0_u0z20) + x(1)*(1-pz2_0_u0)*bh(px0_u0z21)...
    + (1-x(1))*pz2_0_u1*bh(px0_u1z20) + (1-x(1))*(1-pz2_0_u1)*bh(px0_u1z21);
o.Hy_x = px0*entrop(o.Py_x(:,1)) + (1-px0)*entrop(o.Py_x(:,2));
o.Hxy = entrop([o.Pxy(1,:),o.Pxy(2,:)]);
% o.Capacity = Capacity;
% o.Z = Z;
CHout{6} = o;
CHCellout{6} = o.Py_x';


%%%% CHANNEL 7 - (X-(U,Z1)) %%%%
pz1_0_u0 = (1-x(2))*(1-ch(4)) + x(2)*ch(4);
pz1_0_u1 = x(3)*(1-ch(4)) + (1-x(3))*ch(4);
pz1_0_u0x0 = 1-ch(4);
pz1_0_u1x0 = 1-ch(4);
pz1_0_u0x1 = ch(4);
pz1_0_u1x1 = ch(4);
px0_u0z10 = (pz1_0_u0x0 * pu0x0) / (x(1)*pz1_0_u0);
px0_u0z11 = ((1-pz1_0_u0x0) * pu0x0) / (x(1)*(1-pz1_0_u0));
px0_u1z10 = (pz1_0_u1x0 * pu1x0) / ((1-x(1))*pz1_0_u1);
px0_u1z11 = ((1-pz1_0_u1x0) * pu1x0) / ((1-x(1))*(1-pz1_0_u1));


o.ChannelName = 'X_UZ1';
o.Px = [px0,1-px0];
o.Py = [x(1)*pz1_0_u0,x(1)*(1-pz1_0_u0),(1-x(1))*pz1_0_u1,(1-x(1))*(1-pz1_0_u1)]; 
o.Pxy = [pu0x0*pz1_0_u0x0, pu0x0*(1-pz1_0_u0x0), pu1x0*pz1_0_u1x0, pu1x0*(1-pz1_0_u1x0);...
         pu0x1*pz1_0_u0x1, pu0x1*(1-pz1_0_u0x1), pu1x1*pz1_0_u1x1, pu1x1*(1-pz1_0_u1x1)];
o.Px_y = [px0_u0z10 , px0_u0z11, px0_u1z10, px0_u1z11;...
          (1-px0_u0z10), (1-px0_u0z11), (1-px0_u1z10), (1-px0_u1z11)];
o.Py_x = [(pu0x0*pz1_0_u0x0)/px0, (pu0x1*pz1_0_u0x1)/(1-px0);...
          (pu0x0*(1-pz1_0_u0x0))/px0, (pu0x1*(1-pz1_0_u0x1))/(1-px0);...
          (pu1x0*pz1_0_u1x0)/px0, pu1x1*pz1_0_u1x1/(1-px0);...
          (pu1x0*(1-pz1_0_u1x0))/px0, (pu1x1*(1-pz1_0_u1x1))/(1-px0)];
o.Hx = bh(px0);
o.Hy = entrop(o.Py);
o.Hx_y = x(1)*pz1_0_u0*bh(px0_u0z10) + x(1)*(1-pz1_0_u0)*bh(px0_u0z11)...
    + (1-x(1))*pz1_0_u1*bh(px0_u1z10) + (1-x(1))*(1-pz1_0_u1)*bh(px0_u1z11);
o.Hy_x = px0*entrop(o.Py_x(:,1)) + (1-px0)*entrop(o.Py_x(:,2));
o.Hxy = entrop([o.Pxy(1,:),o.Pxy(2,:)]);
% o.Capacity = Capacity;
% o.Z = Z;
CHout{7} = o;
CHCellout{7} = o.Py_x';


%%%% CHANNEL 8 - (X-U) %%%%
o.ChannelName = 'X_U';
o.Px = [px0,1-px0];
o.Py = [x(1),1-x(1)]; 
o.Pxy = [px0*(1-x(2)), px0*x(2);...
         (1-px0)*x(3), (1-px0)*(1-x(3))];
o.Px_y = [1-x(2),x(3) ; x(2),1-x(3)];
o.Py_x = [1-x(2),x(3) ; x(2),1-x(3)];
o.Hx = bh(px0);
o.Hy = bh(o.Py);
o.Hx_y = x(1)*bh(x(2)) + (1-x(1))*bh(x(3));
o.Hy_x = x(1)*bh(x(2)) + (1-x(1))*bh(x(3));
o.Hxy = entrop([o.Pxy(1,:),o.Pxy(2,:)]);
% o.Capacity = Capacity;
% o.Z = Z;
CHout{8} = o;
CHCellout{8} = o.Py_x;


CHo = CHout;
CHoCell = CHCellout;

